/**
 * file name: version.h
 * @author Betti Oesterholz
 * @date 09.08.2010
 * @mail webmaster@BioKom.info
 *
 * System: C++
 *
 * This file contains switches for the different fib -versions.
 * Copyright (C) @c GPL3 2010 Betti Oesterholz
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program. If not, see <http://www.gnu.org/licenses/>.
 *
 *
 * This includes descriptions of declarations for versioned
 * programming switches.
 *
 */
/*
History:
09.08.2010  Oesterholz  created
*/ 

//debugging information; define DEBUG to activate them
//#define DEBUG
#include "debugOut.inc"


#include "./fib/version.h"
#include "./enviroment/version.h"
#include "./enviroment.fib/version.h"
#include "./fib.algorithms/version.h"
#include "./add_ons/converter/version.h"



/**
 * This flag is for code, which is still to implement fully.
 */
#define TODO







